## remctl 2.11

=== java/Makefile ===
# Makefile for Java remctl implementation.
# $Id: Makefile 3387 2007-08-26 06:59:24Z rra $
#
# This Makefile is not (yet) integrated with the rest of the remctl build
# system.  You will need to either edit the JDK setting below or override it
# on the command line with:
#
#     make JDK=/path/to/jdk/directory
#
# Currently, only the Sun Java JDK is supported (1.4.2, 5, or 6).

JDK	= /usr/lib/jvm/java-6-sun-1.6.0.00
JAVAC	= $(JDK)/bin/javac
JAR	= $(JDK)/bin/jar

ORIGIN	= org/eyrie/eagle/remctl
SOURCE	= $(ORIGIN)/RemctlClient.java $(ORIGIN)/RemctlServer.java \
	  $(ORIGIN)/Remctl.java
CLASS	= $(SOURCE:.java=.class)

all: remctl.jar t5.class t7.class

t5.class: t5.java $(CLASS)
	$(JAVAC) -g t5.java

t7.class: t7.java $(CLASS)
	$(JAVAC) -g t7.java

remctl.jar: $(CLASS)
	$(JAR) cfe remctl.jar $(ORIGIN)/RemctlClient $(CLASS)

$(ORIGIN)/RemctlClient.class: $(ORIGIN)/RemctlClient.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlClient.java

$(ORIGIN)/RemctlServer.class: $(ORIGIN)/RemctlServer.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlServer.java

$(ORIGIN)/Remctl.class: $(ORIGIN)/Remctl.java
	$(JAVAC) -g $(ORIGIN)/Remctl.java

clean:
	rm -rf $(ORIGIN)/*.class remctl.jar *.class

## remctl 2.16

=== java/Makefile ===
# Makefile for Java remctl implementation.
#
# This Makefile is not (yet) integrated with the rest of the remctl build
# system.  You will need to either edit the JDK setting below or override it
# on the command line with:
#
#     make JAVA_HOME=/path/to/jdk/directory
#
# Currently, only the Sun Java JDK is supported (1.4.2, 5, or 6).
#
# Originally written by Marcus Watts <mdw@umich.edu>
# Copyright 2007 Marcus Watts
# Copyright 2007, 2008 Board of Trustees, Leland Stanford Jr. University
#
# See LICENSE for licensing terms.

JAVA_HOME ?= /usr/lib/jvm/java-6-sun
JAVAC      = $(JDK)/bin/javac
JAR        = $(JDK)/bin/jar

ORIGIN     = org/eyrie/eagle/remctl
SOURCE     = $(ORIGIN)/RemctlClient.java $(ORIGIN)/RemctlServer.java \
	     $(ORIGIN)/Remctl.java
CLASS	   = $(SOURCE:.java=.class)

all: remctl.jar t5.class t7.class

t5.class: t5.java $(CLASS)
	$(JAVAC) -g t5.java

t7.class: t7.java $(CLASS)
	$(JAVAC) -g t7.java

remctl.jar: $(CLASS)
	$(JAR) cfe remctl.jar $(ORIGIN)/RemctlClient $(ORIGIN)/*.class

$(ORIGIN)/RemctlClient.class: $(ORIGIN)/RemctlClient.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlClient.java

$(ORIGIN)/RemctlServer.class: $(ORIGIN)/RemctlServer.java $(ORIGIN)/Remctl.class
	$(JAVAC) -g $(ORIGIN)/RemctlServer.java

$(ORIGIN)/Remctl.class: $(ORIGIN)/Remctl.java
	$(JAVAC) -g $(ORIGIN)/Remctl.java

clean:
	rm -rf $(ORIGIN)/*.class remctl.jar *.class

=== debian/changelog ===
remctl (2.16-1) unstable; urgency=low

  * New upstream release.
    - Add Ruby bindings (install libremctl-ruby).
    - Add support for PCRE and regex ACLs in the remctl server.
    - remctld now sets REMCTL_COMMAND to the command run.
  * Use dh_gencontrol -- -V to pass the PHP version substvar instead of
    writing it to the substvars file.
  * Switch to 3.0 (quilt) source format.  Force a single Debian patch and
    include a custom patch header explaining that it is a rollup of any
    fixes cherry-picked from upstream and breaking those patches out
    separately would be work for no gain.

 -- Russ Allbery <rra@debian.org>  Sun, 02 May 2010 18:13:50 -0700

remctl (2.15-3) unstable; urgency=low

  * Make use of the new Makefile variables in the upstream 2.15 release to
    control the Python installation and test suite.  Hopefully fixes
    installation with Python 2.6 as the default.  (Closes: #571509)
  * Fix the PHP tests to work properly with PHP 5.3, which no longer
    passes environment variables through to the running test programs.
  * Downgrade the libremctl-dev dependency on libkrb5-dev to suggests
    since it's only required for static linking.
  * Fix a spelling error in the Net::Remctl man page.
  * Update standards version to 3.8.4 (no changes required).

 -- Russ Allbery <rra@debian.org>  Thu, 25 Feb 2010 18:06:48 -0800

remctl (2.15-2) unstable; urgency=low

  * Do not add php5 as an alternative to the phpapi dependency in
    php5-remctl, fixing problems with the upcoming PHP 5.3 transition.
    Thanks, Raphael Geissert.  (Closes: #566300)

 -- Russ Allbery <rra@debian.org>  Fri, 22 Jan 2010 11:21:37 -0800

remctl (2.15-1) unstable; urgency=low

  * New upstream release.
    - Allow the subcommand to be omitted on the remctl command line.
    - New special keyword EMPTY in remctld configuration.
    - Allow use of ALL for the command in the remctld configuration.
    - Fix read of uninitialized memory when parsing ACL files.
  * Fix debian/rules logic for forcing Python module tests to be run using
    the default version of Python.

 -- Russ Allbery <rra@debian.org>  Sun, 29 Nov 2009 18:51:38 -0800

remctl (2.14-4) unstable; urgency=low

  * Add --install-layout=deb to the Python setup.py install commands to
    support Python 2.6.
  * Add php5-cli to the build dependencies so that the test suite is run.
  * Update to debhelper compatibility level V7.
    - Use debhelper rule minimization with overrides.
    - Skip the test suite if nocheck is set in DEB_BUILD_OPTIONS.
    - Let dh_install handle installation of remctl.conf.
    - Add ${misc:Depends} to all dependencies.
  * Apply a build-time fix to the upstream Makefile to only use the Python
    build directory for the default version of Python.  This is required
    now that make check is run after building Python modules for all
    supported versions.
  * Use the right optimization and warning flags when relinking libremctl.

 -- Russ Allbery <rra@debian.org>  Thu, 27 Aug 2009 19:28:16 -0700

remctl (2.14-3) unstable; urgency=low

  * Stop including the protocol documentation in remctl-server.  Add a
    pointer to the remctl-client package for protocol documentation in
    remctl-server's README.Debian.
  * Add a doc-base registration file for the remctl protocol specification
    in remctl-client.
  * Do not install the libremctl.la file.  Libtool *.la files force other
    packages using Libtool to declare excessive library dependencies.
  * Add an explicit build-dependency on Perl.  It was being pulled in by
    other build dependencies, but this is more correct.
  * Update standards version to 3.8.3 (no changes required).

 -- Russ Allbery <rra@debian.org>  Mon, 24 Aug 2009 16:12:57 -0700

remctl (2.14-2) unstable; urgency=low

  * Fix test suite behavior when IPv6 support is available in the library
    but disabled in the kernel.  Thanks, Peter 'p2' De Schrijver.
    (Closes: #530573)
  * Change php5-remctl's section to php to match override.

 -- Russ Allbery <rra@debian.org>  Mon, 08 Jun 2009 00:21:09 -0700

remctl (2.14-1) unstable; urgency=low

  * New upstream release.
    - remctld can be configured to pass an argument on standard input.
    - Arguments passed on standard input may now contain nuls.
    - remctld logging now replaces unprintable characters.
    - "command" and "subcommand" are now used instead of "type" and
      "service" in all documentation of remctl commands.
    - Better diagnosis of nul characters in command arguments.
    - Plug several memory leaks in the remctld server.
  * Allow php5 as an alternative for the phpapi dependency to avoid a
    Lintian warning (although I'm not sure this change is correct and need
    to investigate further later).
  * Update standards version to 3.8.1 (no changes required).

 -- Russ Allbery <rra@debian.org>  Fri, 22 May 2009 16:20:45 -0700

remctl (2.13-3) unstable; urgency=low

  * Upload to unstable.

 -- Russ Allbery <rra@debian.org>  Mon, 16 Feb 2009 20:13:34 -0800

remctl (2.13-2) experimental; urgency=low

  * Call open() with the correct arguments when creating a sentinel file
    in the test suite.  (LP: #307326)

 -- Russ Allbery <rra@debian.org>  Thu, 11 Dec 2008 19:30:14 -0800

remctl (2.13-1) experimental; urgency=low

  * New upstream release.
    - New PHP PECL bindings for libremctl (php5-remctl).
    - New Python remctl extension (python-remctl).
    - Add support for ACL methods to the remctld server.
    - Add the deny ACL method to reject authentication by certain users.
    - Add the princ ACL method, allowing direct specification of
      particular principals in the main configuration file.
    - When processing the include of a directory for configuration or ACL
      files, limit the files included to characters in [a-zA-Z0-9_-] to
      avoid editor temporary files.  (Closes: #479481)
  * On new installations of remctl-server, add the inetd.conf line with


=== debian/control ===
Source: remctl
Section: net
Priority: optional
Maintainer: Russ Allbery <rra@debian.org>
Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.14.9), libkrb5-dev,
 libpcre3-dev, libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev,
 python-support (>= 0.6), ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
Standards-Version: 3.8.4
Homepage: http://www.eyrie.org/~eagle/software/remctl/
Vcs-Git: git://git.eyrie.org/kerberos/remctl.git
Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git

Package: libremctl1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the client libraries linked against MIT Kerberos.

Package: libremctl-dev
Section: libdevel
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libremctl1 (= ${binary:Version})
Suggests: libkrb5-dev
Description: Development files for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the development files for client libraries linked
 against MIT Kerberos.

Package: remctl-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: remctl (<< 1.10-1)
Replaces: remctl (<< 1.10-1)
Description: Client for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the client program (remctl).

Package: remctl-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, update-inetd | inet-superserver,
 netbase (>= 4.31)
Recommends: openbsd-inetd | inet-superserver, tcpd
Conflicts: remctl (<< 1.10-1)
Replaces: remctl (<< 1.10-1)
Description: Server for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the server (remctld).

Package: libnet-remctl-perl
Section: perl
Architecture: any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Description: Perl client for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Net::Remctl Perl library, which provides native
 Perl bindings for the libremctl client library.

Package: php5-remctl
Section: php
Architecture: any
Depends: ${shlibs:Depends}, ${php:Depends}, ${misc:Depends}
Description: PECL module for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the PECL remctl module for PHP 5, which provides
 native PHP bindings for the libremctl client library.

Package: python-remctl
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Python remctl extension, which provides native
 Python bindings for the libremctl client library.

Package: libremctl-ruby
Section: ruby
Architecture: all
Depends: ${misc:Depends}, libremctl-ruby1.8
Description: Ruby extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package is a metapackage that depends on the Ruby bindings for the
 remctl client library for the default version of Ruby.

Package: libremctl-ruby1.8
Section: ruby
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby 1.8 extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Ruby 1.8 remctl extension, which provides
 native Ruby bindings for the libremctl client library for Ruby 1.8.

Package: libremctl-ruby1.9.1
Section: ruby
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby 1.9.1 extension for Kerberos-authenticated command execution
 remctl is a client/server protocol for executing specific commands on a
 remote system with Kerberos authentication.  The allowable commands must
 be listed in a server configuration file, and the executable run on the
 server may be mapped to any command name.  Each command is also
 associated with an ACL containing a list of Kerberos principals
 authorized to run that command.
 .
 This package contains the Ruby 1.9.1 remctl extension, which provides
 native Ruby bindings for the libremctl client library for Ruby 1.9.1.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

# The primary Python version, used to ensure that we run the test suite with
# the module built for the default version of Python.  These are passed into
# the upstream make via overrides of dh_auto_test and dh_auto_install.  Just
# exporting them in the environment doesn't work for some reason.
PYTHON_INSTALL := --install-layout=deb
PYTHON_VERSION := $(shell pyversions -dv)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --sysconfdir=/etc/remctl \
	    --enable-reduced-depends --enable-perl --enable-php \
	    --enable-python --enable-ruby

# We rebuild the remctl client because Automake and Libtool combine to force
# remctl to be linked against all the dependencies of libremctl, which
# creates unnecessary dependencies.  Ones that probably won't matter, mind,
# but let's do this right anyway.
#
# We rebuild the Perl module to encode the right installation paths, since
# otherwise it defaults to using the local site module path.
#
# We rebuild the Python module so that we have builds for each of the
# supported versions of Python.
#
# For the first pass, build the Ruby 1.8 extension.  We'll go back and build
# the extension for 1.9.1.
override_dh_auto_build:
	dh_auto_build -- RUBY=ruby1.8
	cd $(CURDIR)/perl && $(MAKE) clean && perl Makefile.PL \
	    INSTALLDIRS=vendor
	cd $(CURDIR)/perl && $(MAKE) OPTIMIZE="$(CFLAGS)"
	gcc $(CFLAGS) -o client/.libs/remctl client/remctl.o \
	    client/.libs/libremctl.so util/.libs/libutil.a
	set -e; cd python && for v in `pyversions -vs` ; do \
	    CFLAGS="$(CFLAGS)" python$$v setup.py build ; \
	done

override_dh_auto_test:
	LD_LIBRARY_PATH='$(CURDIR)/client/.libs' dh_auto_test \
	    -- PYTHON_VERSION=$(PYTHON_VERSION) RUBY=ruby1.8

# After installing the build for the default version of Ruby, go back and
# rebuild for the newer version.
override_dh_auto_install:
	dh_auto_install -- PYTHON_INSTALL=$(PYTHON_INSTALL) \
	    RUBYARCHDIR='$$(archdir)$$(target_prefix)'
	cd ruby && $(MAKE) distclean
	dh_auto_build -- RUBY=ruby1.9.1
	cd ruby && $(MAKE) install DESTDIR='$(CURDIR)/debian/tmp' \
	    RUBYARCHDIR='$$(archdir)$$(target_prefix)'

# Override install to check for missing installed files and to do the proper
# Python module installation.
override_dh_install:
	set -e; cd python && for v in `pyversions -vs` ; do \
	    python$$v setup.py install --install-layout=deb \
		--root $(CURDIR)/debian/tmp ; \
	done
	dh_install --fail-missing -Xlibremctl.la

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -V 'libremctl1 (>= 2.10)'

# Override dh_gencontrol to set up the substvar for the PHP dependency.
override_dh_gencontrol:
	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

## remctl 2.18

=== debian/changelog ===
remctl (2.18-1) unstable; urgency=low

  * New upstream release.
    - Fix uninitialized variable in remctld standalone server.

 -- Russ Allbery <rra@debian.org>  Tue, 31 May 2011 17:10:09 -0700

remctl (2.17-1) unstable; urgency=low

  * New upstream release.
    - Fix return object construction in the Python simple bindings.
    - Support -b option in remctld to set the bind address.
    - Support IPv6 in remctld when run stand-alone.
    - Add a pkg-config configuration file for libremctl.
    - Set PHP extension test to be noninteractive.
    - Initialize sockaddr structs more correctly.
  * Remove Conflicts/Replaces referring to versions older than oldstable.
  * Update standards version to 3.9.2 (no changes required).

 -- Russ Allbery <rra@debian.org>  Tue, 31 May 2011 15:40:02 -0700

remctl (2.16-2) unstable; urgency=low

  * Skip the getaddrinfo invalid host test if foo.invalid resolves using
    gethostbyname.  This hopefully works around build issues on kFreeBSD.
    (See #626047)
  * Update network utility library from rra-c-util 3.4 to fix problems
    with the test suite on hosts that bind IPv4 addresses when binding
    IPv6 addresses by default.

 -- Russ Allbery <rra@debian.org>  Tue, 10 May 2011 20:53:25 -0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.14.9), libkrb5-dev,
  libpcre3-dev, libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev,
  python-support (>= 0.6), ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git
 Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
@@ -44,8 +44,6 @@
 Package: remctl-client
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: remctl (<< 1.10-1)
-Replaces: remctl (<< 1.10-1)
 Description: Client for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must
@@ -61,8 +59,6 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, update-inetd | inet-superserver,
  netbase (>= 4.31)
 Recommends: openbsd-inetd | inet-superserver, tcpd
-Conflicts: remctl (<< 1.10-1)
-Replaces: remctl (<< 1.10-1)
 Description: Server for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must

## remctl 3.0

=== debian/changelog ===
remctl (3.0-5) unstable; urgency=low

  * Fix the skip count for the network utility test suite, fixing a
    spurious test failure on systems without IPv6.  Patch from Felix
    Geyer.  (Closes: #654982)
  * Fix removal of build directory paths from RPATH when building the Perl
    module inside a build directory that contains regex metacharacters.

 -- Russ Allbery <rra@debian.org>  Sun, 08 Jan 2012 21:01:28 -0800

remctl (3.0-4) unstable; urgency=low

  * Disable the network timeout test for right now since kfreebsd-amd64 is
    still failing.  Add some additional debugging and run the test with
    full output for now so that this test can hopefully be reinstated in a
    later version.

 -- Russ Allbery <rra@debian.org>  Wed, 02 Nov 2011 19:21:14 -0700

remctl (3.0-3) unstable; urgency=low

  * Further test suite fixes for kfreebsd: Skip network timeout tests if a
    short listen queue doesn't cause any connections to fail, and fix the
    bounds handling when closing open sockets if all connections
    succeeded.  (Closes: #647254)

 -- Russ Allbery <rra@debian.org>  Wed, 02 Nov 2011 12:47:06 -0700

remctl (3.0-2) unstable; urgency=low

  * Allow for different networking behavior seen on kfreebsd systems in
    the test suite.  (Closes: #647254)
    - FreeBSD kernel refuses connections after listen queue exhaustion.
    - getaddrinfo may return other errors on invalid host lookups.

 -- Russ Allbery <rra@debian.org>  Tue, 01 Nov 2011 21:07:03 -0700

remctl (3.0-1) unstable; urgency=low

  * New upstream release.
    - New protocol version 3, adding a NOOP command.
    - More consistent and formal handling of continuation commands.
    - The server no longer closes the connection after version or error
      replies.
    - Add new remctl_set_source_ip function to set the source IP address
      for outgoing client connections.
    - Add new -b option to remctl command-line client to set source IP.
    - Add new remctl_set_ccache function to specify the credential store
      to use for GSS-API authentication.
    - Fix a client memory leak on remctl_close.
    - Send QUIT to the server when reopening a remctl object.
  * Convert libremctl to multiarch.
  * Update to (experimental) debhelper compatibility level V9.
    - Add Pre-Depends: ${misc:Pre-Depends} to libremctl1.
    - Use dpkg-buildflags to set CFLAGS.
    - Enable bindnow hardening.  Leave pie off for right now.
    - Add Lintian override for using an experimental debhelper level.
  * Update Python packaging to use dh_python2.
    - Add XS-Python-Version to debian/control.
    - Add python2 debhelper add-on to debian/rules.
    - Remove build dependency on python-support.

 -- Russ Allbery <rra@debian.org>  Mon, 31 Oct 2011 18:05:11 -0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: net
 Priority: optional
 Maintainer: Russ Allbery <rra@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.14.9), libkrb5-dev,
+Build-Depends: debhelper (>= 8.1.3~), dpkg-dev (>= 1.14.9), libkrb5-dev,
  libpcre3-dev, libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev,
- python-support (>= 0.6), ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
+ ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
+XS-Python-Version: >= 2.6
 Standards-Version: 3.9.2
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git
@@ -13,6 +14,8 @@
 Package: libremctl1
 Section: libs
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Library for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,13 @@
 #!/usr/bin/make -f
 
-CFLAGS = -Wall -g
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-    CFLAGS += -O0
-else
-    CFLAGS += -O2
-endif
+# Add additional hardening features.  +pie not added for right now since it
+# needs testing to ensure it doesn't break the shared library and module
+# builds.
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+
+# Get CFLAGS for rebuilding the remctl client binary and Perl and Python
+# modules.
+CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
 
 # The primary Python version, used to ensure that we run the test suite with
 # the module built for the default version of Python.  These are passed into
@@ -15,7 +17,7 @@
 PYTHON_VERSION := $(shell pyversions -dv)
 
 %:
-	dh $@
+	dh $@ --with python2
 
 override_dh_auto_configure:
 	dh_auto_configure -- --sysconfdir=/etc/remctl \
@@ -49,6 +51,8 @@
 override_dh_auto_test:
 	LD_LIBRARY_PATH='$(CURDIR)/client/.libs' dh_auto_test \
 	    -- PYTHON_VERSION=$(PYTHON_VERSION) RUBY=ruby1.8
+	echo '=== Special test run for debugging kfreebsd-amd64 ==='
+	tests/runtests -o util/network
 
 # After installing the build for the default version of Ruby, go back and
 # rebuild for the newer version.
@@ -73,8 +77,7 @@
 	dh_installchangelogs NEWS
 
 override_dh_makeshlibs:
-	dh_makeshlibs -V 'libremctl1 (>= 2.10)'
+	dh_makeshlibs -V 'libremctl1 (>= 3.0)'
 
-# Override dh_gencontrol to set up the substvar for the PHP dependency.
 override_dh_gencontrol:
 	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

## remctl 3.1

=== java/Makefile ===
--- 
+++ 
@@ -10,7 +10,8 @@
 #
 # Originally written by Marcus Watts <mdw@umich.edu>
 # Copyright 2007 Marcus Watts
-# Copyright 2007, 2008 Board of Trustees, Leland Stanford Jr. University
+# Copyright 2007, 2008
+#     The Board of Trustees of the Leland Stanford Junior University
 #
 # See LICENSE for licensing terms.

=== debian/changelog ===
remctl (3.1-1~bpo60+1) squeeze-backports; urgency=low

  * Backport to squeeze.
  * Remove dependency and use of dh-autoreconf and use the upstream build
    system, since the version in stable is quite old.
  * Remove multiarch support.

 -- Russ Allbery <rra@debian.org>  Thu, 22 Mar 2012 09:52:23 -0700

remctl (3.1-1) unstable; urgency=low

  * New upstream release.
    - New remctl_set_timeout function and corresponding API in all the
      language bindings to set a timeout on all further network operations
      on that client connection.
    - remctld supports a user configuration option to run a program as a
      specific user (with supplemental groups).
    - remctld's timeout is now one hour between messages instead of a
      total limit of one hour for the connection.
    - PHP's remctl_output no longer warns on failure.
    - Python's _remctl.remctl_output returns an empty tuple on error.
    - Fix error reporting for non-blocking connect.

 -- Russ Allbery <rra@debian.org>  Wed, 29 Feb 2012 13:14:14 -0800

remctl (3.0-6) unstable; urgency=low

  * Patch the upstream build system to provide more hooks for Perl and
    Python builds and make use of them, removing all the complexity in
    debian/rules to selectively rebuild parts of the source.  As a side
    effect, fix application of the hardening flags to all of the
    interpretor modules.
  * Use dh-autoreconf to rebuild the Autotools build system, and link with
    --as-needed to remove the additional unnecessarily library
    dependencies for the client.  Remove the workaround of relinking the
    binary, which removed the hardening flags.
  * Pass the hardening flags into the Perl and Python module rebuilds.
  * Depend on debhelper (>= 9) now that V9 is no longer experimental and
    remove now-unneeded Lintian override.
  * Remove the special additional test run for kfreebsd-amd64.  The
    problem has been located and corrected upstream.

 -- Russ Allbery <rra@debian.org>  Sat, 04 Feb 2012 20:21:09 -0800

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: net
 Priority: optional
 Maintainer: Russ Allbery <rra@debian.org>
-Build-Depends: debhelper (>= 8.1.3~), dpkg-dev (>= 1.14.9), libkrb5-dev,
- libpcre3-dev, libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev,
- ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
+Build-Depends: debhelper (>= 9), libkrb5-dev, libpcre3-dev,
+ libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev, ruby1.8,
+ ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
 XS-Python-Version: >= 2.6
 Standards-Version: 3.9.2
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
@@ -14,7 +14,6 @@
 Package: libremctl1
 Section: libs
 Architecture: any
-Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Library for Kerberos-authenticated command execution

=== debian/rules ===
#!/usr/bin/make -f

# Add hardening build flags.  We have to omit PIE because it breaks the Perl
# module build (and probably the other interpretors as well).
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# Link with --as-needed so that the remctl client library doesn't inherit
# the shared library dependencies of libremctl.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The additional flags to pass to Makefile.PL, picked up by the upstream
# build system.
export REMCTL_PERL_FLAGS := INSTALLDIRS=vendor

# The supported Python versions and the additional Python flags, picked up
# by the upstream build system.
export REMCTL_PYTHON_INSTALL  := --install-layout=deb
export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)

%:
	dh $@ --with python2

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- --sysconfdir=/etc/remctl \
	    --enable-reduced-depends --enable-perl --enable-php \
	    --enable-python --enable-ruby

# For the first pass, build the Ruby 1.8 extension.  We'll go back and build
# the extension for 1.9.1.
override_dh_auto_build:
	dh_auto_build -- REMCTL_RUBY=ruby1.8

override_dh_auto_test:
	dh_auto_test -- REMCTL_RUBY=ruby1.8

# After installing the build for the default version of Ruby, go back and
# rebuild for the newer version.
override_dh_auto_install:
	dh_auto_install -- RUBYARCHDIR='$$(archdir)$$(target_prefix)'
	cd ruby && $(MAKE) distclean
	dh_auto_build -- REMCTL_RUBY=ruby1.9.1
	cd ruby && $(MAKE) install DESTDIR='$(CURDIR)/debian/tmp' \
	    RUBYARCHDIR='$$(archdir)$$(target_prefix)'

# Override install to check for missing installed files.
override_dh_install:
	dh_install --fail-missing -Xlibremctl.la

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -V 'libremctl1 (>= 3.1)'

override_dh_gencontrol:
	dh_gencontrol -- -V"php:Depends=phpapi-`php-config5 --phpapi`"

## remctl 3.2

=== debian/changelog ===
remctl (3.2-4) unstable; urgency=low

  * Cherry-pick upstream fix to close a file descriptor leak in remctld
    when checking access against ACL files.

 -- Russ Allbery <rra@debian.org>  Thu, 27 Sep 2012 21:12:59 -0700

remctl (3.2-3) unstable; urgency=low

  * Cherry-pick upstream fix to flags passed to open() when creating
    sentinel files in the test suite.  Hopefully fixes FTBFS on Hurd.

 -- Russ Allbery <rra@debian.org>  Thu, 28 Jun 2012 13:57:28 -0700

remctl (3.2-2) unstable; urgency=low

  * Cherry-pick upstream fix to add proper dependencies on libremctl.la to
    the build rules for other language bindings.  This should fix
    occasional FTBFS problems with parallel builds.  Thanks, Aaron
    M. Ucko.  (Closes: #679307)

 -- Russ Allbery <rra@debian.org>  Wed, 27 Jun 2012 16:32:57 -0700

remctl (3.2-1) unstable; urgency=low

  * New upstream release.
    - If remctld receives a help command with no arguments and no help
      command is explicitly defined, it will look for commands to which
      the current user has access and for which the summary option is set
      and run them with the argument given by the summary option,
      collecting the output and sending it back to the client.
    - If remctld receives a help command with one or two arguments and a
      command entry exists matching those arguments, the user has access
      to run it, and the help option is set, the command is run with the
      help option as the subcommand.
    - Always close the server's connection to the client on low-level
      network and GSS-API errors.
    - Fix remctld segfault when the configuration does not define any
      commands.
  * Update Ruby extension packaging for the new Ruby standard.  The
    ruby-remctl package replaces all libremctl-ruby* packages, which are
    now transitional packages to ease the upgrade.  The Ruby extension is
    now installed in the vendor_ruby directory and the modules for all
    supported Ruby versions are included in the same package.
  * Switch to xz compression for the upstream and Debian tarballs.
  * Move single-debian-patch to local-options and patch-header to
    local-patch-header so that they only apply to the packages I build and
    NMUs get regular version-numbered patches.
  * Enable parallel builds.
  * Mark libremctl-dev Multi-Arch: same and remctl-client and
    remctl-server Multi-Arch: foreign.
  * Convert debian/copyright to copyright-format 1.0.
  * Update standards version to 3.9.3 (no changes required).

 -- Russ Allbery <rra@debian.org>  Tue, 19 Jun 2012 20:19:03 -0700

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: net
 Priority: optional
 Maintainer: Russ Allbery <rra@debian.org>
-Build-Depends: debhelper (>= 9), libkrb5-dev, libpcre3-dev,
- libtest-pod-perl, perl, php5-cli, php5-dev, python-all-dev, ruby1.8,
- ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
+Build-Depends: debhelper (>= 9), dh-autoreconf, dpkg-dev (>= 1.14.9),
+ libkrb5-dev, libpcre3-dev, libtest-pod-perl, perl, php5-cli, php5-dev,
+ python-all-dev, ruby1.8, ruby1.8-dev, ruby1.9.1, ruby1.9.1-dev
 XS-Python-Version: >= 2.6
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://www.eyrie.org/~eagle/software/remctl/
 Vcs-Git: git://git.eyrie.org/kerberos/remctl.git
 Vcs-Browser: http://git.eyrie.org/?p=kerberos/remctl.git
@@ -14,6 +14,7 @@
 Package: libremctl1
 Section: libs
 Architecture: any
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Library for Kerberos-authenticated command execution
@@ -30,6 +31,7 @@
 Section: libdevel
 Priority: extra
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libremctl1 (= ${binary:Version})
 Suggests: libkrb5-dev
 Description: Development files for Kerberos-authenticated command execution
@@ -45,6 +47,7 @@
 
 Package: remctl-client
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Client for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
@@ -58,6 +61,7 @@
 
 Package: remctl-server
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}, update-inetd | inet-superserver,
  netbase (>= 4.31)
 Recommends: openbsd-inetd | inet-superserver, tcpd
@@ -117,10 +121,12 @@
  This package contains the Python remctl extension, which provides native
  Python bindings for the libremctl client library.
 
-Package: libremctl-ruby
+Package: ruby-remctl
 Section: ruby
-Architecture: all
-Depends: ${misc:Depends}, libremctl-ruby1.8
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Replaces: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
+Breaks: libremctl-ruby1.8 (<< 3.2), libremctl-ruby1.9 (<< 3.2)
 Description: Ruby extension for Kerberos-authenticated command execution
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must
@@ -129,14 +135,15 @@
  associated with an ACL containing a list of Kerberos principals
  authorized to run that command.
  .
- This package is a metapackage that depends on the Ruby bindings for the
- remctl client library for the default version of Ruby.
+ This package contains the Ruby remctl extension, which provides native
+ Ruby bindings for the libremctl client library.
 
-Package: libremctl-ruby1.8
-Section: ruby
+Package: libremctl-ruby
+Section: oldlibs
+Priority: extra
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: Ruby 1.8 extension for Kerberos-authenticated command execution
+Depends: ${misc:Depends}, ruby-remctl
+Description: Ruby extension for remctl (transitional package)
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must
  be listed in a server configuration file, and the executable run on the
@@ -144,14 +151,15 @@
  associated with an ACL containing a list of Kerberos principals
  authorized to run that command.
  .
- This package contains the Ruby 1.8 remctl extension, which provides
- native Ruby bindings for the libremctl client library for Ruby 1.8.
+ This is a transitional package to handle upgrades from the older Ruby
+ extension naming scheme.  It can be safely removed.
 
-Package: libremctl-ruby1.9.1
-Section: ruby
+Package: libremctl-ruby1.8
+Section: oldlibs
+Priority: extra
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: Ruby 1.9.1 extension for Kerberos-authenticated command execution
+Depends: ${misc:Depends}, ruby-remctl
+Description: Ruby 1.8 extension for remctl (transitional package)
  remctl is a client/server protocol for executing specific commands on a
  remote system with Kerberos authentication.  The allowable commands must
  be listed in a server configuration file, and the executable run on the
@@ -159,5 +167,21 @@
  associated with an ACL containing a list of Kerberos principals
  authorized to run that command.
  .
- This package contains the Ruby 1.9.1 remctl extension, which provides
- native Ruby bindings for the libremctl client library for Ruby 1.9.1.
+ This is a transitional package to handle upgrades from the older Ruby
+ 1.8 extension naming scheme.  It can be safely removed.
+
+Package: libremctl-ruby1.9.1
+Section: oldlibs
+Priority: extra
+Architecture: any
+Depends: ${misc:Depends}, ruby-remctl
+Description: Ruby 1.9.1 extension for remctl (transitional package)
+ remctl is a client/server protocol for executing specific commands on a
+ remote system with Kerberos authentication.  The allowable commands must
+ be listed in a server configuration file, and the executable run on the
+ server may be mapped to any command name.  Each command is also
+ associated with an ACL containing a list of Kerberos principals
+ authorized to run that command.
+ .
+ This is a transitional package to handle upgrades from the older Ruby
+ 1.9.1 extension naming scheme.  It can be safely removed.

=== debian/rules ===
--- 
+++ 
@@ -18,32 +18,32 @@
 export REMCTL_PYTHON_VERSIONS := $(shell pyversions -s)
 
 %:
-	dh $@ --with python2
+	dh $@ --parallel --with python2,autoreconf
 
 override_dh_autoreconf:
 	dh_autoreconf --as-needed
 
 override_dh_auto_configure:
-	dh_auto_configure -- --sysconfdir=/etc/remctl \
+	dh_auto_configure --parallel -- --sysconfdir=/etc/remctl \
 	    --enable-reduced-depends --enable-perl --enable-php \
 	    --enable-python --enable-ruby
 
 # For the first pass, build the Ruby 1.8 extension.  We'll go back and build
 # the extension for 1.9.1.
 override_dh_auto_build:
-	dh_auto_build -- REMCTL_RUBY=ruby1.8
+	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.8
 
 override_dh_auto_test:
-	dh_auto_test -- REMCTL_RUBY=ruby1.8
+	dh_auto_test --parallel -- REMCTL_RUBY=ruby1.8
 
 # After installing the build for the default version of Ruby, go back and
 # rebuild for the newer version.
 override_dh_auto_install:
-	dh_auto_install -- RUBYARCHDIR='$$(archdir)$$(target_prefix)'
+	dh_auto_install -- RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'
 	cd ruby && $(MAKE) distclean
-	dh_auto_build -- REMCTL_RUBY=ruby1.9.1
+	dh_auto_build --parallel -- REMCTL_RUBY=ruby1.9.1
 	cd ruby && $(MAKE) install DESTDIR='$(CURDIR)/debian/tmp' \
-	    RUBYARCHDIR='$$(archdir)$$(target_prefix)'
+	    RUBYARCHDIR='$$(vendorarchdir)$$(target_prefix)'
 
 # Override install to check for missing installed files.
 override_dh_install:

=== debian/watch ===
# watch -- Rules for uscan to find new upstream versions.
# $Id$
#
# I don't use this personally since I'm also the upstream maintainer, but
# it's included for the benefit of automated package analysis systems.

version=3
http://archives.eyrie.org/software/kerberos/remctl-(.*)\.tar\.gz
